<?php

// třída reprezentující fakturu je potomkem DOMDocumentu
class Faktura extends DOMDocument
{
  // metoda pro snadné sečtení celé faktury
  function secti()
  {
    $suma = 0;

    foreach ($this->getElementsByTagName("cena") as $cena)
    {
      $suma += $cena->textContent * (1 + $cena->getAttribute("dph") / 100);
    }

    return $suma;
  }

  // metoda pro snadné přidání nové položky
  function pridejPolozku($popis, $cena, $dph)
  {
    // vytvoření elementu polozka
    $polozka = $this->createElement("polozka");

    // vytvoření elementu popis
    $popis = $this->createElement("popis", $popis);

    // vytvoření elementu cena
    $cena = $this->createElement("cena", $cena);
    $cena->setAttribute("dph", $dph);

    // připojení elementů popis a cena k elementu polozka
    $polozka->appendChild($popis);
    $polozka->appendChild($cena);

    // připojení nové položky na konec faktury
    $this->documentElement->appendChild($polozka);
  }
}

// Nastavení výstupního typu dat
Header("Content-type: text/plain;charset=utf-8");

// načtení XML dokumentu s fakturou do paměti
$faktura = new Faktura();
$faktura->load("../data/faktura.xml"); 

echo "Původní součet faktury: " . $faktura->secti() . "\n";

// přidání nové položky
$faktura->pridejPolozku("Buráky", "59", "5");

echo "Součet faktury po přidání buráků: " . $faktura->secti() . "\n";

// vypsání modifikované faktury na výstup
echo "Nová podoba faktury:\n" . $faktura->saveXML();

?>