<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

<xsl:output method="xml" encoding="utf-8" indent="yes" 
            doctype-public="-//WAPFORUM//DTD WML 1.1//EN"
            doctype-system="http://www.wapforum.org/DTD/wml_1.1.xml"/>

<xsl:template match="/">
  <wml>
    <xsl:for-each select="vina/vino[position() mod 5 = 1]">
      <card title="Přehled vín {position()}/{last()}" id="{generate-id()}">
        <xsl:if test="following-sibling::vino[5]">
          <do type="accept" label="Další">
            <go href="#{generate-id(following-sibling::vino[5])}"/>
          </do>
        </xsl:if>
        <xsl:if test="preceding-sibling::vino[5]">
          <do type="prev" label="Předchozí">
            <go href="#{generate-id(preceding-sibling::vino[5])}"/>
          </do>
        </xsl:if>
        <xsl:apply-templates select=".|following-sibling::vino[1]
                                      |following-sibling::vino[2]
                                      |following-sibling::vino[3]
                                      |following-sibling::vino[4] "/>
      </card>
    </xsl:for-each>
  </wml>
</xsl:template>

<xsl:template match="vino">
  <p>
    <xsl:apply-templates/>
  </p>
</xsl:template>

<xsl:template match="odruda">
  <xsl:apply-templates/>
</xsl:template>

<xsl:template match="barva">
</xsl:template>

<xsl:template match="popis">
</xsl:template>

<xsl:template match="rocnik">
  (<xsl:apply-templates/>)
</xsl:template>

<xsl:template match="cena">
  <xsl:apply-templates/> Kč
</xsl:template>

</xsl:stylesheet>