<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.01//EN'>
<html lang="cs">
  <head>
    <meta http-equiv="content-type" content="text/html;charset=utf-8">
    <title>Ukázka rozšíření třídy SimpleXMLElement</title>
  </head>
  <body>
<?php

// nová třída XMLElement je potomkem SimpleXMLElement
class XMLElement extends SimpleXMLElement
{
  // nová metoda, která vrací objekt usnadňující přístup k atributům
  function attrs()
  {
    if (func_num_args() == 0)
    {
      // při volání metody bez parametrů je přístup k lokálním atributům
      return new XMLAttributes(parent::attributes());
    }
    else
    {
      // při volání s parametrem je přístup jen k atributům v daném jmenném prostoru
      return new XMLAttributes(parent::attributes(func_get_arg(0)));
    }
  }
}

// třída reprezentující atributy
class XMLAttributes
{
  // soukromá členská proměnná pro dočasné uschování atributů elementu
  private $attributes;
  
  // konstruktor
  function __construct($attributes)
  {
    // převzaté atributy se uloží do členské proměnné
    $this->attributes = $attributes;
  }

  // univerzální metoda, která se volá při přístupu k neznámé vlastnosti/členské proměnné
  function __get($name)
  {
    if (isset($this->attributes[$name])) 
    {
      // jestliže atribut daného jména existuje, vrátíme jeho hodnotu
      return $this->attributes[$name];
    } 
    else 
    {
      // jinak vrátíme false
      return false;
    }
  }
}

// ukázka jednoduchého přečtení atributu nepatřícího do jmenného prostoru
$xml =  simplexml_load_file("../data/faktura.xml", "XMLElement",
                            LIBXML_NOENT|LIBXML_DTDLOAD|LIBXML_DTDATTR);
echo $xml->attrs()->splatnost;

echo "<br>\n";

// ukázka přečtení atributu patřícího do jmenného prostoru XLink
$xml =  simplexml_load_file("../data/ns.xml", "XMLElement",
                            LIBXML_NOENT|LIBXML_DTDLOAD|LIBXML_DTDATTR);
echo $xml->para->phrase->attrs("http://www.w3.org/1999/xlink")->href;

?>
  </body>
</html>