<?php 
Header("Content-type: text/plain; charset=utf-8");

// nastavení vlastní obsluhy chyb
libxml_use_internal_errors(true);

// vytvoření nového XMLReaderu
$reader = new XMLReader();

// otevření souboru pro čtení
$reader->open("../schema/zamestnanci-chyba.xml",
              LIBXML_NOENT|LIBXML_DTDLOAD|LIBXML_DTDATTR);

// nastavení schématu, oproti kterému se má dokument validovat
$reader->setSchema("../schema/zamestnanci.xsd");

// postupně čteme celý dokument
while ($reader->read()) {}

// vznikly při načítání dokumentu nějaké chyby?
if (!$reader->isValid())
{
  echo "Dokument není validní:\n";

  // načtení validačních chyb
  $errors = libxml_get_errors();

  // postupné zpracování všech chyb
  foreach ($errors as $error)
  {
    // u každé chyby vypíšeme jméno souboru, řádek, sloupec a chybové hlášení
    echo $error->file . ":" . $error->line . ":" . $error->column . ":" . $error->message . "\n";
  }
  
  // vyčištění chyb
  libxml_clear_errors();
  exit;
}
else
{
  echo "Dokument je validní oproti W3C XML schématu.";
}

?>