<?php

// funkce vracející maximální číselnou hodnotu ze seznamu uzlů
function maxValue($nl)
{
  // funkci byl předán prázdný seznam uzlů, nic se nevrací
  if (count($nl) == 0)
    return false;
    
  // funkci byl předán jeden uzel, je i ne největší
  if (count($nl) == 1)
    return (double)$nl[0]->textContent;
  else
  {
    // postupně se projdou všechny uzly a do proměnné $max
    // se uloží nejvyší nalezená hodnota
    $max = (double)$nl[0]->textContent;
    foreach ($nl as $node)
    {
      if ((double)$node->textContent > $max)
        $max = (double)$node->textContent;
    }
    return $max;
  }
}

// funkce vracející uzel s maximální číselnou hodnotu ze seznamu uzlů
// funguje analogicky jako předchozí, ale místo hodnoty vrací uzel, který
// tuto hodnotu obsahoval
function maxNode($nl)
{
  if (count($nl) == 0)
    return false;
    
  if (count($nl) == 1)
    return $nl[0];
  else
  {
    $max = (double)$nl[0]->textContent;
    $maxNode = $nl[0];
    foreach ($nl as $node)
    {
      if ((double)$node->textContent > $max)
      {
        $max = (double)$node->textContent;
        $maxNode = $node;
      }
    }
    return $maxNode;
  }
}

// načtení dokumentu XML
$xml = new DomDocument();
$xml->load("../data/katalog.xml", LIBXML_NOENT|LIBXML_DTDLOAD|LIBXML_DTDATTR);

// načtení stylu XSLT
$xsl = new DomDocument();
$xsl->load("php-funkce.xsl", LIBXML_NOENT|LIBXML_DTDLOAD|LIBXML_DTDATTR);

// vytvoření procesoru XSLT
$proc = new xsltprocessor();
// zaregistrování funkcí PHP pro použití v XSLT
$proc->registerPhpFunctions();
// načtení stylu do XSLT procesoru
$proc->importStylesheet($xsl);

// provedení transformace a vypsání výsledku
echo $proc->transformToXML($xml);

?>